#include <iostream>

template<typename T>
struct base {
	void calculate() {
		return static_cast<T*>(this)->doCalculate();
	}
};

struct derived : base<derived> {
	void doCalculate() {
		std::cout << "derived" << std::endl;
	}
};

int main() {
	derived d;
	d.calculate();
	return 0;
}
